<?php
require("class.phpmailer.php"); // 邮箱发送组件
/**
 * Q空间日志同步插件,实现独立博客与Q日志同步。(邮箱发Q空间)
 * 开启插件后,请先设置好发送邮件配置和指定QQZone邮箱.
 *
 * @package EQzone
 * @author CSW
 * @version 1.0.0
 * @link http://www.jmyxw.com
 */
class EQzone_Plugin implements Typecho_Plugin_Interface
{
    /**
     * 激活插件方法,如果激活失败,直接抛出异常
     *
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function activate()
    {
        Typecho_Plugin::factory('Widget_Abstract_Contents')->filter = array('EQzone_Plugin', 'doHandler');
		return _t('请对插件进行正确设置，以使插件顺利工作！') . $error;
    }

    /**
     * 禁用插件方法,如果禁用失败,直接抛出异常
     *
     * @static
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function deactivate(){}

    /**
     * 获取插件配置面板
     *
     * @access public
     * @param Typecho_Widget_Helper_Form $form 配置面板
     * @return void
     */
    public static function config(Typecho_Widget_Helper_Form $form){
    
         $cfg_host = new Typecho_Widget_Helper_Form_Element_Text('cfg_host', NULL, 'smtp.qq.com',
                _t('STMP地址：'),_t('请填写 SMTP 服务器地址。例如：smtp.qq.com - 端口默认25'));
        $form->addInput($cfg_host->addRule('required', _t('填写STMP地址')));
        
        $cfg_user = new Typecho_Widget_Helper_Form_Element_Text('cfg_user', NULL, NULL,
                _t('邮箱服务器账号'),_t('你的邮箱发送服务器账号 如:XXX@QQ.COM'));
        $form->addInput($cfg_user->addRule('required', _t('发送邮箱账户')));

        $cfg_pass = new Typecho_Widget_Helper_Form_Element_Password('cfg_pass', NULL, NULL,
                _t('邮箱服务器密码'),_t('你的邮箱密码'));
        $form->addInput($cfg_pass->addRule('required', _t('QQ密码')));
        
       $cfg_ToEmail = new Typecho_Widget_Helper_Form_Element_Text('cfg_ToEmail', NULL, 'xx@qzone.qq.com',
               _t('发送到目标邮箱'),_t('你的邮箱发送服务器账号 如:XX@qzone.qq.com'));
       $form->addInput($cfg_ToEmail ->addRule('required', _t('发送邮箱账户')));

		$cfg_mode = new Typecho_Widget_Helper_Form_Element_Radio('cfg_mode',
                array( 0 => '仅新建时同步',1 => '新建和修改时同步'),'0', '选择同步的时机');
		$form->addInput($cfg_mode);
		
		$cfg_format = new Typecho_Widget_Helper_Form_Element_Textarea('cfg_format', NULL, '{more}
<br>
<b>本文来自映轩晓屋：</b>{link} .',
			_t('发送内容设置'), _t('标题{title}  文章链接{link}  文章摘要/内容{more}<br/>摘要/内容会被截取前1800字,建议摘要/内容和标题不要混合使用..'));
        $form->addInput($cfg_format);
	}

    /**
     * 个人用户的配置面板
     *
     * @access public
     * @param Typecho_Widget_Helper_Form $form
     * @return void
     */
    public static function personalConfig(Typecho_Widget_Helper_Form $form){}

    /**
     * 实际处理方法
     * 
     * @param Widget_Contents_Post_Edit $content,$class
     * @return array 返回变换后的$value
     */
    public static function doHandler($content,$class)
    {
		$options = Typecho_Widget::widget('Widget_Options')->plugin('EQzone');
		if(get_class($class) != 'Widget_Contents_Post_Edit'){
			return $content;
		}
		if($options->cfg_mode == '1'){
			if(!$class->request->is("do=publish") 
				||($class->request->is("do=publish") && !$class->have())){
				
				return $content;
			}
			//file_put_contents('./usr/plugins/WbtoSync/cache/' . "1.txt",$class->request->do . date('H:i:s') . "\n" ,FILE_APPEND);
		}else{
			if(!$class->request->is("do=publish") 
				||($class->request->is("do=publish") && !empty($class->request->cid))){
				return $content;
			}
		}
		
		if($options->cfg_format){
			$format = $options->cfg_format;
		}else{
			$format = '我刚发表了一篇博文《{title}》,链接地址：{link} .';
		}
		
		//标题
		$title = $content['title'];
		//短链接
		$link = self::getSinaUrl($content['permalink']);
		if(strpos($format,'{more}')  !== false ){
			//摘要
			if(strpos($content['text'], '<!--more-->')  !== false ){
				$more_t = explode('<!--more-->', $content['text']);
				list($more) = $more_t;
				$more = Typecho_Common::fixHtml(Typecho_Common::cutParagraph($more));
				//$more = Typecho_Common::subStr(strip_tags($more), 0, 1800, '...');
				$more = Typecho_Common::subStr($more, 0, 1800, '...');
			}else{
				$more = $content['text'];
				$more = Typecho_Common::fixHtml(Typecho_Common::cutParagraph($more));
				//$more = Typecho_Common::subStr(strip_tags($more), 0, 1800, '...');
				$more = Typecho_Common::subStr($more, 0, 1800, '...');
			}
		}else{
			$more = "";
		}
		$search = array('{title}','{link}','{more}');
		$replace = array($title,$link,$more);
		$format = str_replace($search,$replace,$format);
		
		// 获取插件设置 信息
		$username = $options->cfg_user;
		$password  = $options->cfg_pass;
		$ToEmail  = $options->cfg_ToEmail;
		$host= $options->cfg_host;
		// 获取插件设置 信息结束
		
		// 以下为，发送邮件核心代码
   $mail = new PHPMailer();
   $mail->IsSMTP();                                      // set mailer to use SMTP
   // $mail->Host = "smtp.126.com;smtp.126.com";  // specify main and backup server
   $mail->Host = $host;  // specify main and backup server
   $mail->SMTPAuth = true;     // turn on SMTP authentication
   $mail->Username = $username ; //"CSW8923@126.com";  // SMTP username
   $mail->Password = $password ; //"CSW520#Lss23"; // SMTP password
   // $mail->From = "CSW8923@126.com";
   $mail->From = $username;
   $mail->FromName = "Mailer";
   //$mail->AddAddress("CSW8923@QQ.com", "Josh Adams");
   $mail->AddAddress($ToEmail , "Josh Adams");
   //$mail->AddAddress("ellen@example.com");                  // name is optional
   $mail->AddReplyTo("CSW8923@126.com", "Information");
   $mail->WordWrap = 1800;                                 // set word wrap to 50 characters
   //$mail->AddAttachment("/var/tmp/file.tar.gz");         // add attachments
   //$mail->AddAttachment("/tmp/image.jpg", "new.jpg");    // optional name
   $mail->IsHTML(true);                                  // set email format to HTML
   $mail->Subject = $title;
   $mail->Body    = $format ;
   $mail->AltBody = $content['text'];

    if(!$mail->Send())
    {
          echo "邮件无法发送. <p>";
          echo "邮箱 Error: " . $mail->ErrorInfo;
          exit;
    }
    echo "消息已发送";
   // 以上为，发送邮件核心代码
   
		return $content;
    }
    
    
    //生成新浪网址网址短链接
	public static function getSinaUrl($url)
	{
		$api_url = 'http://api.t.sina.com.cn/short_url/shorten.json';
		$api_key = '2261244958';
		$send_url = $api_url . '?source=' . $api_key . '&url_long='.urlencode($url);
		$client = Typecho_Http_Client::get();
		if ($client) {
			try {
				$client->setTimeout(5)
				->send($send_url);
				
				$result = json_decode($client->getResponseBody());
				
				unset($client);
				return $result[0]->url_short;
				
			} catch (Typecho_Http_Client_Exception $e) {
				return $url;
			}
		}
		return $url;
	}
	
}
